unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, jpeg;

type
  TMainF = class(TForm)
    FileOpenBtn: TButton;
    OpenDialog1: TOpenDialog;
    GrayBtn: TButton;
    first_derivationBtn: TButton;
    second_derivativeBtn: TButton;
    PrewittBtn: TButton;
    HilditchBtn: TButton;
    firstGainEdt: TLabeledEdit;
    DevNoEdt: TLabeledEdit;
    SecondGainEdt: TLabeledEdit;
    DevNo2Edt: TLabeledEdit;
    PrewittEdt: TLabeledEdit;
    thresholdEdt: TLabeledEdit;
    MinusBox: TCheckBox;
    MinusOBox: TCheckBox;
    GrayHidiBtn: TButton;
    procedure FileOpenBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure GrayBtnClick(Sender: TObject);
    procedure first_derivationBtnClick(Sender: TObject);
    procedure second_derivativeBtnClick(Sender: TObject);
    procedure PrewittBtnClick(Sender: TObject);
    procedure HilditchBtnClick(Sender: TObject);
    procedure GrayHidiBtnClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  MainF: TMainF;

implementation

{$R *.dfm}

var
  Graydata        : array of array of byte;
  Image_out1      : array of array of byte;
  Image_out2      : array of array of byte;
  BWidth, BHeight : integer;
  Vcrect          : TRect;
  threshold       : integer = 150;                // l
  amp             : single = 1.5;                 // 
  ampf            : single = 3.0;                 // 
  amps            : single = 1.5;                 // 

  Dvt1            : integer = 1;                  // Iy[^[ԍ
  Dvt2            : integer = 1;

// ꎟ Iy[^[
  cx0       : array[0..8] of integer = ( 0, 0, 0,     // ꎟ Gradient ʏ̔ Iy[^[
                                         0, 1,-1,
                                         0, 0, 0);
  cy0       : array[0..8] of integer = ( 0, 0, 0,
                                         0, 1, 0,
                                         0,-1, 0);
  cx1       : array[0..8] of integer = ( 0, 0, 0,     // ꎟ Gradient Roberts    Iy[^[
                                         0, 1, 0,
                                         0, 0,-1);
  cy1       : array[0..8] of integer = ( 0, 0, 0,
                                         0, 0, 1,
                                         0,-1, 0);
  cx2       : array[0..8] of integer = (-1,-2,-1,     // ꎟ Gradient Soble     Iy[^[
                                         0, 0, 0,
                                         1, 2, 1);
  cy2       : array[0..8] of integer = (-1, 0, 1,
                                        -2, 0, 2,
                                        -1, 0, 1);

// 񎟔Iy[^[
  c0        : array[0..8] of integer = ( 1, 1, 1,     // 񎟔 Laplacian           Iy[^[
                                         1,-8, 1,
                                         1, 1, 1);
  c1        : array[0..8] of integer = ( 0, 1, 0,
                                         1,-4, 1,
                                         0, 1, 0);
  c2        : array[0..8] of integer = (-1, 2,-1,
                                         2,-4, 2,
                                        -1, 2,-1);

// Prewittp@}XN
  cd        : array[0..7,0..8] of integer = (( 1, 1, 1,   // Prewitt @}XN
                                               1,-2, 1,
                                              -1,-1,-1),
                                             ( 1, 1, 1,
                                               1,-2,-1,
                                               1,-1,-1),
                                             ( 1, 1,-1,
                                               1,-2,-1,
                                               1, 1,-1),
                                             ( 1,-1,-1,
                                               1,-2,-1,
                                               1, 1, 1),
                                             (-1,-1,-1,
                                               1,-2, 1,
                                               1, 1, 1),
                                             (-1,-1, 1,
                                              -1,-2, 1,
                                               1, 1, 1),
                                             (-1, 1, 1,
                                              -1,-2, 1,
                                              -1, 1, 1),
                                             ( 1, 1, 1,
                                              -1,-2, 1,
                                              -1,-1, 1));

// 3 X 3 f[^[op SWZl
  dy        : array[0..8] of integer = (-1,-1,-1,
                                         0, 0, 0,
                                         1, 1, 1);
  dx        : array[0..8] of integer = (-1, 0, 1,
                                        -1, 0, 1,
                                        -1, 0, 1);

const
  HIGH  =$FF;               // Ql摜 f[^[


procedure TMainF.FormCreate(Sender: TObject);
begin
  Width   := 900;
  Height  := 600;
  Left := (Screen.Width - Width) div 2;
  Top  := (Screen.Height - Height) div 2;
//  Vcrect  := Rect(50, 30, 305, 285);               // rbg}bv\TCYʒuݒ
  FileOpenbtn.Left          := 600;
  GrayBtn.Left              := 600;
  first_derivationBtn.Left  := 600;
  second_derivativeBtn.Left := 600;
  PrewittBtn.Left           := 600;
  HilditchBtn.Left          := 600;

  FileOpenbtn.top           := 25;
  GrayBtn.top               := 70;
  first_derivationBtn.Top   := 115;
  second_derivativeBtn.Top  := 160;
  PrewittBtn.Top            := 250;
  HilditchBtn.Top           := 295;

  firstGainEdt.Left         := 719;
  DevNoEdt.Left             := 800;
  firstGainEdt.Top          := 117;
  DevNoEdt.Top              := 117;

  SecondGainEdt.Left        := 719;
  DevNo2Edt.Left            := 800;
  SecondGainEdt.Top         := 164;
  DevNo2Edt.Top             := 164;

  MinusBox.top              := 190;
  MinusBox.Left             := 720;
  MinusOBox.Top             := 212;
  MinusOBox.Left            := 720;
  GrayHidiBtn.Top           := 295;
  GrayHidiBtn.Left          := 790;

  PrewittEdt.Left           := 719;
  PrewittEdt.Top            := 254;

  thresholdEdt.Left         := 719;
  thresholdEdt.Top          := 299;

  firstGainEdt.Text   := floatTostr(ampf);
  DevNoEdt.Text       := intTostr(Dvt1);
  SecondGainEdt.Text  := floatTostr(amps);
  DevNo2Edt.Text      := intTostr(Dvt2);
  PrewittEdt.Text     := floatTostr(amp);
  thresholdEdt.Text   := intTostr(threshold);

  GrayHidiBtn.Caption := 'GrayQl';

  GrayBtn.Enabled := False;
  first_derivationBtn.Enabled := False;
  second_derivativeBtn.Enabled := False;
  PrewittBtn.Enabled := False;
  HilditchBtn.Enabled := False;
  GrayHidiBtn.Enabled := False;
end;

procedure TMainF.FileOpenBtnClick(Sender: TObject);
var
  BitmapD     : Tbitmap;                          // Windows rbg}bvC[W
  jpgD        : TJPEGImage;                       // jpegC[W
  P           : PByteArray;                       // TbyteArray |C^[
  R, G, B     : Byte;                             // RGBvZp
  XX, YY, GG  : Integer;                          // for loop  GG |C^[vZp
  RParam, GParam, BParam : Cardinal;              // ColorW
  Extstr      : string;
begin
  FileOpenBtn.Enabled := False;
  if OpenDialog1.Execute then                     // t@Cw肳ꂽ
    begin
      Extstr := ExtractFileExt(OpenDialog1.FileName);
      Extstr := LowerCase(Extstr);
      BitmapD := Tbitmap.Create;                  // rbg}bvC[W̐
      if Extstr = '.jpg' then begin               // jpegt@C
        jpgD := TJPEGImage.Create;                // jpegC[W̐
        try
          jpgD.LoadFromFile(OpenDialog1.FileName);  // jpegt@Cǂݍ
          BitmapD.Assign(jpgD);                     // rbg}bvɕϊ
        finally
          jpgD.Free;                              // jpegC[W̉
        end;
      end
      else
       BitmapD.LoadFromFile(OpenDialog1.FileName); // rbg}bvt@C̓ǂݍ
    end
    else
    begin
      FileOpenBtn.Enabled := True;
      exit;                                       // t@CIȂI
    end;
  if BitmapD.PixelFormat <> pf24bit then          // 24rbgJ[tH[}bgłȂI
    begin
      application.MessageBox('tH[}bgႢ܂ 24rbgtH[}bgKvłB', '', 0);
      BitmapD.Free;
      FileOpenBtn.Enabled := True;
      exit;
    end;
  HilditchBtn.Enabled := False;
  BWidth   := BitmapD.Width;                      // rbg}bv擾
  BHeight  := BitmapD.Height;                     // rbg}bv擾

  Vcrect  := Rect(50, 30, 561, 541);              // rbg}bv\TCYʒuݒftHg

  Canvas.Brush.Style := bsSolid;
  Canvas.Brush.Color := clBtnFace;
  Canvas.FillRect(Vcrect);                        // Canvas 摜

  if BWidth > BHeight then begin                  // 傫ꍇ
    YY := 30 + round(512 * BHeight / BWidth);
    Vcrect  := Rect(50, 30, 561, YY);             // rbg}bv\TCYʒuݒ
  end;

  if BWidth < BHeight then begin                  // c傫ꍇ
    XX := 50 + round(512 *  BWidth / BHeight);
    Vcrect  := Rect(50, 30, XX, 541);             // rbg}bv\TCYʒuݒ
  end;
  Canvas.StretchDraw(Vcrect, BitmapD);            // Xgb`\

// OCf[^[쐬
  RParam := Trunc(0.298912 * 2048);               // FW쐬
  GParam := Trunc(0.586611 * 2048);
  BParam := Trunc(0.114478 * 2048);
  SetLength(Graydata, BHeight, Bwidth);           // O[XP[z񒷂Zbg
  for YY := 0 to BHeight - 1 do                   // O[XP[f[^[
    begin
      P := BitmapD.Scanline[YY];                  // rbg}bvC|C^[擾
      for XX := 0 to BWidth -1 do                 // PC
        begin
          GG := XX * 3;                           // PsNZRoCgȂ̂łR{
          B := (P[GG    ] * BParam) shr 11;       // 
          G := (P[GG + 1] * GParam) shr 11;       // 
          R := (P[GG + 2] * Rparam) shr 11;       // 
          Graydata[YY, XX] := R + G + B;          // OF̉Z
        end;
    end;
  BitmapD.Free;                                   // rbg}bv̔j
  FileOpenBtn.Enabled := True;
  GrayBtn.Enabled := True;
  first_derivationBtn.Enabled := True;
  second_derivativeBtn.Enabled := True;
  PrewittBtn.Enabled := True;
  GrayHidiBtn.Enabled := True;
end;

procedure TMainF.GrayBtnClick(Sender: TObject);   // Pɕ\̂
var
  GBitmap     : TBitmap;                          // Windows rbg}bv
  P           : PByteArray;                       // TbyteArray |C^[
  XX, YY, PD  : integer;                          // for loop p PD |C^[vZp
  DD          : byte;                             // bytef[^[
begin
  GBitmap := TBitmap.Create;                      // \prbg}bv
  GBitmap.PixelFormat := pf24bit;                 // QSrbgJ[
  GBitmap.Width   := BWidth;                      // ̐ݒ
  GBitmap.Height  := BHeight;                     // ̐ݒ
  for YY := 0 to BHeight - 1 do                   // rbg}bṽf[^[쐬
    begin
      P := GBitmap.ScanLine[YY];                  // |C^[̎擾
      begin
        for XX := 0 to BWidth - 1 do              // C
          begin
            DD := Graydata[YY, XX];               // zf[^[擾
            PD := XX * 3;                         // PsNZRoCgȂ̂łR{
            P[PD]     := DD;                      // RGBOFɓlZbg
            P[PD + 1] := DD;
            P[PD + 2] := DD;
          end;
      end;
    end;
  Canvas.StretchDraw(Vcrect, GBitmap);            // Xgb`\
  GBitmap.Free;                                   // rbg}bv̔j
end;

procedure TMainF.first_derivationBtnClick(Sender: TObject);
var
  d         : array[0..8] of integer;
  i, j, dat : integer;
  k         : integer;
  xx, yy, zz: single;
  GBitmap   : TBitmap;                          // Windows rbg}bv
  P         : PByteArray;                       // TbyteArray |C^[
  DD        : byte;
begin
  val(firstGainEdt.Text, ampf, i);
  if i <> 0 then application.MessageBox('͂Ɍ肪܂B','', 0);
  val(DevNoEdt.Text, Dvt1, i);
  if i <> 0 then application.MessageBox('͂Ɍ肪܂B','', 0);
  setlength(Image_out1, BHeight, BWidth);
  for i := 1 to BHeight - 2 do
    for j := 1 to BWidth - 2 do begin
      for K := 0 to 8 do                          // O[f[^[o
        d[k] := Graydata[i + dy[k],j + dx[k]];
      xx := 0;
      yy := 0;
      case Dvt1 of                                // Iy[^[̑I
        1:  for k := 0 to 8 do begin
              xx := xx + cx0[k] * d[k];
              yy := yy + cy0[k] * d[k];
            end;
        2:  for k := 0 to 8 do begin
              xx := xx + cx1[k] * d[k];
              yy := yy + cy1[k] * d[k];
            end;
        else
            for k := 0 to 8 do begin
              xx := xx + cx2[k] * d[k];
              yy := yy + cy2[k] * d[k];
            end;
      end;
      zz := ampf * sqrt(xx * xx + yy * yy);
      dat := round(zz);
      if dat > HIGH then dat := HIGH;
        Image_out1[ i, j] := byte(dat);
    end;
  GBitmap := TBitmap.Create;                      // \prbg}bv
  GBitmap.PixelFormat := pf24bit;                 // QSrbgJ[
  GBitmap.Width   := BWidth;                      // ̃Zbg
  GBitmap.Height  := BHeight;                     // cZbg
  for j := 0 to BHeight - 1 do                    // rbg}bṽf[^[쐬
    begin
      P := GBitmap.ScanLine[j];                   // |C^[̎擾
      begin
        for i := 0 to BWidth - 1 do               // C
          begin
            DD := Image_out1[j, i];               // zf[^[擾
            k  := i * 3;                          // PsNZRoCgȂ̂łR{
            P[k]     := DD;                       // RGBOFɓlZbg
            P[k + 1] := DD;
            P[k + 2] := DD;
          end;
      end;
    end;
  Canvas.StretchDraw(Vcrect, GBitmap);            // Xgb`\
  GBitmap.Free;
  HilditchBtn.Enabled := True;
end;

procedure TMainF.second_derivativeBtnClick(Sender: TObject);
var
  d         : array[0..8] of integer;
  i, j, dat : integer;
  k         : integer;
  z, zz     : single;
  GBitmap   : TBitmap;                          // Windows rbg}bv
  P         : PByteArray;                       // TbyteArray |C^[
  DD        : byte;
begin
  val(SecondGainEdt.Text, amps, i);
  if i <> 0 then application.MessageBox('͂Ɍ肪܂B','', 0);
  val(DevNo2Edt.Text, Dvt2, i);
  if i <> 0 then application.MessageBox('͂Ɍ肪܂B','', 0);
  setlength(Image_out1, BHeight, BWidth);
  for i := 1 to BHeight - 2 do begin
    for j := 1 to BWidth - 2 do begin
      for K := 0 to 8 do                          // O[f[^[o
        d[k] := Graydata[i + dy[k],j + dx[k]];
      z := 0;
      case Dvt2 of                                // Iy[^[̑I
          1: for k := 0 to 8 do z := z + c0[k] * d[k];
          2: for k := 0 to 8 do z := z + c1[k] * d[k];
        else
             for k := 0 to 8 do z := z + c2[k] * d[k];
      end;
      zz := amps * z;
      if MinusOBox.Checked then zz := -zz;                  // }CiX\
      if not MinusBox.Checked then if zz < 0 then zz := 0;  // }CiX͖Ă݂܂
      dat := round(abs(zz));
      if dat > HIGH then dat := HIGH;
      Image_out1[ i, j] := byte(dat);
    end;
  end;
  GBitmap := TBitmap.Create;                      // \prbg}bv
  GBitmap.PixelFormat := pf24bit;                 // QSrbgJ[
  GBitmap.Width   := BWidth;                      // ̃Zbg
  GBitmap.Height  := BHeight;                     // cZbg
  for j := 0 to BHeight - 1 do                    // rbg}bṽf[^[쐬
    begin
      P := GBitmap.ScanLine[j];                   // |C^[̎擾
      begin
        for i := 0 to BWidth - 1 do               // C
          begin
            DD := Image_out1[ j, i];              // zf[^[擾
            k  := i * 3;                          // PsNZRoCgȂ̂łR{
            P[k]     := DD;                       // RGBOFɓlZbg
            P[k + 1] := DD;
            P[k + 2] := DD;
          end;
      end;
    end;
  Canvas.StretchDraw(Vcrect, GBitmap);            // Xgb`\
  GBitmap.Free;
  HilditchBtn.Enabled := True;
end;

procedure TMainF.PrewittBtnClick(Sender: TObject);
var
  i,j,k,l,max,dat             : integer;
  m   : array[0..7] of integer;
  d   : array[0..8] of integer;
  zz  : single;
  GBitmap   : TBitmap;                          // Windows rbg}bv
  P         : PByteArray;                       // TbyteArray |C^[
  DD        : byte;
begin
  val(PrewittEdt.Text, amp, i);
  if i <> 0 then application.MessageBox('͂Ɍ肪܂B','', 0);
  setlength(Image_out1, BHeight, BWidth);
  for i := 1 to BHeight - 2 do
    for j := 1 to BWidth - 2 do begin
      for K := 0 to 8 do                                      // O[f[^[o
        d[k] := Graydata[i + dy[k],j + dx[k]];
      for k := 0 to 7 do begin                                // }XN cd[ k, l]
        m[k] := 0;
        for l := 0 to 8 do m[k] := m[k] + d[l] * cd[ k, l];
      end;
      max := 0;
      for k := 0 to 7 do                                      // ől
        if max < m[k] then max := m[k];
      zz := amp * max;
      dat := round(zz);
      if dat > HIGH then dat := HIGH;
      Image_out1[ i, j] := byte(dat);
    end;
  GBitmap := TBitmap.Create;                      // \prbg}bv
  GBitmap.PixelFormat := pf24bit;                 // QSrbgJ[
  GBitmap.Width   := BWidth;                      // ̃Zbg
  GBitmap.Height  := BHeight;                     // cZbg
  for j := 0 to BHeight - 1 do                    // rbg}bṽf[^[쐬
    begin
      P := GBitmap.ScanLine[j];                   // |C^[̎擾
      begin
        for i := 0 to BWidth - 1 do               // C
          begin
            DD := Image_out1[ j, i];              // zf[^[擾
            k  := i * 3;                          // PsNZRoCgȂ̂łR{
            P[k]     := DD;                       // RGBOFɓlZbg
            P[k + 1] := DD;
            P[k + 2] := DD;
          end;
      end;
    end;
  Canvas.StretchDraw(Vcrect, GBitmap);            // Xgb`\
  GBitmap.Free;
  HilditchBtn.Enabled := True;
end;

procedure TMainF.HilditchBtnClick(Sender: TObject);   // א
var
  i, ix, iy               : integer;
  icd, iac, ibc              : integer;
  candidate               : integer;
  ia : array[0..8] of integer;
  ic : array[0..7] of integer;
  GBitmap     : TBitmap;                          // Windows rbg}bv
  P           : PByteArray;                       // TbyteArray |C^[
  DD          : byte;                             // bytef[^[

  function conect(inb: array of integer): integer;  // AiAj𒲂ׂ
  var
    i, icn :integer;
  begin
    icn := 0;
    for i := 0 to 3 do
      if inb[i * 2] = 0 then                      // EAAA [
        if (inb[i * 2 +  1] = HIGH) or (inb[i * 2 + 2] = HIGH) then inc(icn); // ׂ̗̎薔͎̎΂HIGHJEg
    Result := icn;
  end;

label
  Cont;
begin
  val(thresholdEdt.Text, threshold, i);           // 臒l̃Zbg
  if i <> 0 then application.MessageBox('͂Ɍ肪܂B','', 0);
  setlength(Image_out2, BHeight, BWidth);
// Ql
  for iy := 0 to BHeight - 1 do                   // Ql
    for ix := 0 to Bwidth - 1 do begin
      if image_out1[iy, ix] > threshold then      // Ql
        image_out2[iy, ix] := HIGH
      else
        image_out2[iy, ix] := 0;
    end;
// א
  candidate   := 100;
  icd  := 1;
  while icd <> 0 do begin
    icd := 0;
    for iy := 1 to BHeight -2 do
      for ix := 1 to BWidth - 2 do begin
        if image_out2[iy, ix] <> HIGH then goto Cont;     // S HIGH Ŗ ̍Wւ
        ia[0] := image_out2[iy  ,ix+1];                   // f[^[o ͂Wӏ E
        ia[1] := image_out2[iy-1,ix+1];                   // E
        ia[2] := image_out2[iy-1,ix  ];                   // 
        ia[3] := image_out2[iy-1,ix-1];                   // 
        ia[4] := image_out2[iy  ,ix-1];                   // 
        ia[5] := image_out2[iy+1,ix-1];                   // 
        ia[6] := image_out2[iy+1,ix  ];                   // 
        ia[7] := image_out2[iy+1,ix+1];                   // E
        for i := 0 to 7 do                                // ͔ӏ High mF
          if ia[i] = candidate then begin                 // HIGȞ₪
            ia[i] := HIGH;                                // AmFp HIGH ɂ
            ic[i] := 0;                                   // `FbNp[Zbg
          end
          else
          begin
            if ia[i] < HIGH then ia[i] := 0;              // OXYXLHIGH₪AAmFpLZ
            ic[i] := ia[i];                               // `FbNpɃRs[
          end;
        ia[8] := ia[0];                                   // conect() Ŏgp̈׃Rs[
        if ia[0] + ia[2] + ia[4] + ia[6] = HIGH * 4 then goto Cont; // ㉺EHIGH ̍W
        iac := 0;
        ibc := 0;
        for i := 0 to 7 do begin                          // HIGHJEg
          if ia[i] = HIGH then inc(iac);                  // HIGH̐JEg AmFp iac[]
          if ic[i] = HIGH then inc(ibc);                  // HIGȞHIGHϊ HIGHJEg `FbNp ic[]
        end;
        if iac <= 1 then goto Cont;                       // ia[] HIGH͈ȉ  ̍W
        if ibc =  0 then goto Cont;                       // ic[] HIGH[              ̍W
        if conect(ia) <> 1 then goto Cont;                // AȊO                       ̍W
        if image_out2[iy - 1, ix] = candidate then begin  // 㑤HIGH₪
          ia[2] := 0;                                     // ̓XLl0ɂ(HIGH)
          if conect(ia) <> 1 then goto Cont;              // AȊO                       ̍W
          ia[2] := HIGH;                                  // ̓XLl֖߂
        end;
        if image_out2[ iy,ix - 1] = candidate then begin  // HIGH₪
          ia[4] := 0;                                     // ̓XLl0ɂ(HIGH)
          if conect(ia) <> 1 then goto Cont;              // AȊO                       ̍W
        end;
        image_out2[iy, ix] := candidate;                  // SWHIGȞɂ
        inc(icd);                                         // HiGȞJE^[CNg
Cont:
      end;
    inc(candidate);
  end;

// HIGH ̌₪c
  for iy :=0 to BHeight -1 do
    for ix := 0 to BWidth - 1 do
      if image_out2[ iy, ix] < HIGH then image_out2[ iy, ix] := 0;
// \
  GBitmap := TBitmap.Create;                      // \prbg}bv
  GBitmap.PixelFormat := pf24bit;                 // WrbgJ[
  GBitmap.Width   := BWidth;                      // ̃Zbg
  GBitmap.Height  := BHeight;                     // cZbg
  for iy := 0 to BHeight - 1 do                   // rbg}bṽf[^[쐬
    begin
      P := GBitmap.ScanLine[iy];                  // |C^[̎擾
      begin
        for ix := 0 to BWidth - 1 do              // C
          begin
            DD := Image_out2[ iy, ix];            // zf[^[擾
            i  := ix * 3;                         // PsNZRoCgȂ̂łR{
            P[i]     := DD;                       // RGBOFɓlZbg
            P[i + 1] := DD;
            P[i + 2] := DD;
          end;
      end;
    end;
  Canvas.StretchDraw(Vcrect, GBitmap);            // Xgb`\
  GBitmap.Free;
end;

procedure TMainF.GrayHidiBtnClick(Sender: TObject);
var
  ix, iy, k   : integer;
  GBitmap     : TBitmap;
  P           : PByteArray;                       // TbyteArray |C^[
  DD          : byte;                             // bytef[^[
begin
  val(thresholdEdt.Text, threshold, ix);          // 臒l̃Zbg
  if ix <> 0 then application.MessageBox('͂Ɍ肪܂B','', 0);

  setlength(Image_out1, BHeight, BWidth);

  for iy := 0 to BHeight - 1 do                   // Ql
    for ix := 0 to Bwidth - 1 do
      if Graydata[iy, ix] > threshold then
        image_out1[iy, ix] := HIGH
      else
        image_out1[iy, ix] := 0;

  GBitmap := TBitmap.Create;                      // \prbg}bv
  GBitmap.PixelFormat := pf24bit;                 // WrbgJ[
  GBitmap.Width   := BWidth;                      // ̃Zbg
  GBitmap.Height  := BHeight;                     // cZbg
  for iy := 0 to BHeight - 1 do                   // rbg}bṽf[^[쐬
    begin
      P := GBitmap.ScanLine[iy];                  // |C^[̎擾
      begin
        for ix := 0 to BWidth - 1 do              // C
          begin
            DD := Image_out1[ iy, ix];            // zf[^[擾
            k  := ix * 3;                         // PsNZRoCgȂ̂łR{
            P[k]     := DD;                       // RGBOFɓlZbg
            P[k + 1] := DD;
            P[k + 2] := DD;
          end;
      end;
    end;
  Canvas.StretchDraw(Vcrect, GBitmap);            // Xgb`\
  GBitmap.Free;
  HilditchBtn.Enabled := True;
end;


end.
